chance_for_alternate_field	= 20	--%
rp_cost_variance_min		= 9 	--10%
rp_cost_variance_max		= 13	--10%

alternates = {
    hydroponic_farm 			= "advanced_engineering",
    dauntless_guidance_system 	= "military_tactics",
    research_laboratory 		= "advanced_construction",
    automated_factories 		= "optronics",
    heavy_armor 				= "fusion_physics",
    planetary_missile_base 		= "military_tactics",
    fusion_rifle 				= "advanced_construction",
    deuterium_fuel_cells 		= "advanced_magnetism",
    tritanium_armor 			= "advanced_fusion",
    battle_pods 				= "advanced_metallurgy",
    survival_pods				= "advanced_metallurgy",
    ecm_jammer 					= "tachyon_physics",
    mass_driver 				= "advanced_metallurgy",
    battle_scanner				= "capsule_construction",
    tachyon_scanner				= "advanced_magnetism",
    augmented_engines			= "advanced_metallurgy",
    fusion_drive				= "advanced_magnetism",
    cloning_center				= "advanced_chemistry",
    death_spores				= "artificial_intelligence",
    soil_enrichment				= "astro_engineering",
    neural_scanner				= "advanced_biology",
    security_stations			= "astro_engineering",
    fighter_garrison			= "artificial_intelligence",
    spaceport					= "artificial_intelligence",
    merculite_missile			= "gravitic_fields",
    pollution_processor			= "robotics",
    battlestation				= "gravitic_fields",
    powered_armor				= "xeno_relations",
    anti_grav_harness			= "robotics",
    alien_management_center		= "robotics",
    telepathic_training			= "positronics",
    holo_simulator				= "neutrino_physics",
    planetary_supercomputer		= "neutrino_physics",
    advanced_damage_control		= "positronics",
    fast_missile_racks			= "ion_fission",
    planetary_radiation_shield	= "servo_mechanics",
    warp_dissipator				= "neutrino_physics",
    neutron_blaster				= "ion_fission",
    neutron_scanner				= "positronics",
    ion_drive					= "magneto_gravitics",
    shield_capacitors			= "servo_mechanics",
    terraforming				= "macro_economics",
    atmospheric_renewer			= "genetic_mutations",
    pulson_missile				= "artificial_gravity",
    battleoids					= "gravitic_fields",
    ground_batteries			= "macro_economics",
    planetary_gravity_generator	= "astro_construction",
    subterranean_farms			= "advanced_manufacturing",
    weather_control_system		= "artificial_consciousness",
    emissions_guidance_system	= "electromagnetic_refraction",
    rangemaster_unit			= "subspace_physics",
    planet_construction			= "macro_genetics",
    automated_repair_unit		= "artificial_consciousness",
    personal_shield				= "subspace_physics",
    stealth_suit				= "advanced_manufacturing",
    jump_gate					= "advanced_manufacturing",
    microlite_construction		= "advanced_robotics",
    zortrium_armor				= "multi_phased_physics",
    bomber_bays					= "anti_matter_fission",
    robotic_factory				= "teaching_methods",
    lightning_field				= "multi_phased_physics",
    pulsar						= "anti_matter_fission",
    phasor_rifle				= "nano_technology",
    anti_matter_drive			= "warp_fields",
    anti_matter_torpedo			= "advanced_robotics",
    astro_university			= "advanced_robotics",
    heightened_intelligence		= "cybertronics",
    structural_analyzer			= "matter_energy_conversion",
    gauss_cannon				= "matter_energy_conversion",
    multi_wave_ecm_jammer		= "cybertronics",
    food_replicators			= "evolutionary_genetics",
    transporters				= "subspace_fields",
    android_workers				= "plasma_physics",
    deep_core_mining			= "plasma_physics",
    core_waste_dumps			= "high_energy_distribution",
    hard_shields				= "high_energy_distribution",
    stasis_field				= "cybertechnics",
    plasma_cannon				= "high_energy_distribution",
    plasma_web					= "distortion_fields",
    energy_absorber				= "distortion_fields",
    megafluxers					= "plasma_physics",
    bio_terminator				= "molecular_manipulation",
    neutronium_armor			= "multi_dimensional_physics",
    uridium_fuel_cells			= "quantum_fields",
    virtual_reality_network		= "artificial_life",
    class_vii_shield			= "multi_dimensional_physics",
    planetary_flux_shield		= "hyper_dimensional_fission",
    wide_area_jammer			= "multi_dimensional_physics",
    disrupter_cannon			= "hyper_dimensional_fission",
    hyper_drive					= "multi_dimensional_physics",
    hyper_x_capacitors			= "quantum_fields",
    achilles_targeting_unit		= "hyper_dimensional_physics",
    pleasure_dome				= "superscalar_construction",
    advanced_city_planning		= "galactic_economics",
    hyperspace_communications	= "galactic_economics",
    sensors						= "moleculartronics",
    biomorphic_fungi			= "planetoid_construction",
    gaia_transformation			= "planetoid_construction",
    doom_star_construction		= "transwarp_fields",
    displacement_device			= "planetoid_construction",
    thorium_fuel_cells			= "interphased_fission",
    neutronium_bomb				= "molecular_control",
    class_x_shield				= "temporal_physics",
    phasing_cloak				= "temporal_physics",
    planetary_barrier_shield	= "temporal_physics",
    star_gate					= "temporal_fields",
    stellar_converter			= "temporal_fields",
    time_warp_facilitator		= "temporal_fields"
}

function set_id(t, tag)
    for i,v in pairs(t) do
        v[tag] = i
    end
end

function go()
    set_seed()
    local fields = rget_fields() 
    set_id(fields, "name")

    if rp_cost_variance_min>rp_cost_variance_max then
        rp_cost_variance_min=rp_cost_variance_max
    end

    if rp_cost_variance_min>1 then
        for field_name,field_content in pairs(fields) do
            fields[field_name].cost=fields[field_name].cost+((fields[field_name].cost/10)*((random(rp_cost_variance_max-rp_cost_variance_min+1)-1+rp_cost_variance_min)-10))
        end
        rset_fields(fields)
    end

    local tree_good = false  

    while not(tree_good) do
        local techs = rget_techs()  
        set_id(techs, "name")

        if chance_for_alternate_field > 80 then
            chance_for_alternate_field=80
        end

        for tech_name,alt_field in pairs(alternates) do
           if random(100) < chance_for_alternate_field then
               techs[tech_name].field_id16=alt_field
           end
        end

        local field_tech_count = {}
   
        for tech_name,tech_content in pairs(techs) do
            if field_tech_count[techs[tech_name].field_id16] == nil then 
                field_tech_count[techs[tech_name].field_id16] = 0
            end 
            field_tech_count[techs[tech_name].field_id16] = field_tech_count[techs[tech_name].field_id16]+1
        end

        tree_good=true

        for field_name,tech_count in pairs(field_tech_count) do
            if (tech_count<1 or tech_count>4) and (field_name~="xenon_technology") then
                tree_good=false
            end
        end

        if tree_good then
            rset_techs(techs)
        end
    end
end

go()
--msgbox("Tech tree has been randomized")
